/**
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 * 
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
**/

#ifndef __CDOS_AUDIT_HELPER_H__
#define __CDOS_AUDIT_HELPER_H__

#include <core/cdos-def.h>
#include <core/cdos-list.h>
#include <audit/cdos-audit-query-cond.h>
#include <audit/cdos-audit-query-config.h>

CDOS_BEGIN_DECLS

typedef struct _CdosAuHelper CdosAuHelper;
typedef void (*CdosAuHelperRetCb)(CdosList* resultList, CdosPointer user_data);

CDOS_EXPORT CdosAuHelper* cdos_au_helper_get_default();

CDOS_EXPORT int cdos_au_helper_query(CdosAuHelper* self,
                                     const CdosAuQueryCond* cond,
                                     CdosAuHelperRetCb cb,
                                     CdosPointer user_data);

CDOS_EXPORT int cdos_au_helper_query_by_config(CdosAuHelper* self,
                                               const char* configFile,
                                               CdosAuHelperRetCb cb,
                                               CdosPointer user_data);

CDOS_EXPORT int cdos_au_helper_delete_log_by_rootdir(CdosAuHelper* self,
                                                     const char* logrootdir);

CDOS_END_DECLS

#endif // __CDOS_AUDIT_HELPER_H__