/**
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 * 
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
**/

#ifndef __CDOS_STRING_H__
#define __CDOS_STRING_H__

#include <core/cdos-def.h>
#include <core/cdos-list.h>

CDOS_BEGIN_DECLS

CDOS_EXPORT CdosUInt cdos_strLen(const char* str);
CDOS_EXPORT CdosList* cdos_strSplit(const char* str, char c);
CDOS_EXPORT char* cdos_strSub(const char* str, CdosUInt pos, CdosInt len);

CDOS_EXPORT char* cdos_strjoin(const char* str, CdosList* strlist);
CDOS_EXPORT char* cdos_strncat(char* dest, CdosUInt destMaxlen, const char* src);

CDOS_EXPORT char* cdos_strncpy(char* dest, CdosUInt destMaxlen, const char* src);

CDOS_EXPORT int cdos_strtoi(const char* str, CdosBoolean* isOk);

CDOS_EXPORT char* cdos_strdup(const char* str);
CDOS_EXPORT char* cdos_strndup(const char* str, CdosUInt length);
CDOS_EXPORT char* cdos_strdup_printf(const char* format, ...) CDOS_FORMAT_FUNCTION(1, 2);

CDOS_EXPORT CdosInt cdos_strIndexOfChar(const char* str, char chr, CdosInt from, CdosBoolean caseSensitive);
CDOS_EXPORT CdosInt cdos_strIndexOfStr(const char* str, const char* needle, CdosInt from, CdosBoolean caseSensitive);

CDOS_EXPORT CdosBoolean cdos_strIsEmpty(const char* str);

CDOS_EXPORT CdosBoolean cdos_strIsEqual(const char* str, const char* other);
CDOS_EXPORT CdosInt cdos_strCmp(const char* str, const char* other);
CDOS_EXPORT CdosInt cdos_strNCmp(const char* str, const char* other, CdosUInt len);

CDOS_EXPORT char* cdos_strRmCharHead(char* dest, char c);
CDOS_EXPORT char* cdos_strRmCharTail(char* dest, char c);
CDOS_EXPORT char* cdos_strRmCharHeadAndTail(char* dest, char c);

CDOS_END_DECLS

#endif // __CDOS_STRING_H__